<?php

namespace xt_soapapi\xt_soapapi-php\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEcartStock ArrayType
 * @subpackage Arrays
 */
class ArrayOfEcartStock extends AbstractStructArrayBase
{
    /**
     * The EcartStock
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \xt_soapapi\xt_soapapi-php\StructType\EcartStock[]
     */
    public $EcartStock;
    /**
     * Constructor method for ArrayOfEcartStock
     * @uses ArrayOfEcartStock::setEcartStock()
     * @param \xt_soapapi\xt_soapapi-php\StructType\EcartStock[] $ecartStock
     */
    public function __construct(array $ecartStock = array())
    {
        $this
            ->setEcartStock($ecartStock);
    }
    /**
     * Get EcartStock value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \xt_soapapi\xt_soapapi-php\StructType\EcartStock[]|null
     */
    public function getEcartStock()
    {
        return isset($this->EcartStock) ? $this->EcartStock : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEcartStock method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEcartStock method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEcartStockForArrayConstraintsFromSetEcartStock(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEcartStockEcartStockItem) {
            // validation for constraint: itemType
            if (!$arrayOfEcartStockEcartStockItem instanceof \xt_soapapi\xt_soapapi-php\StructType\EcartStock) {
                $invalidValues[] = is_object($arrayOfEcartStockEcartStockItem) ? get_class($arrayOfEcartStockEcartStockItem) : sprintf('%s(%s)', gettype($arrayOfEcartStockEcartStockItem), var_export($arrayOfEcartStockEcartStockItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EcartStock property can only contain items of type \xt_soapapi\xt_soapapi-php\StructType\EcartStock, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EcartStock value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \xt_soapapi\xt_soapapi-php\StructType\EcartStock[] $ecartStock
     * @return \xt_soapapi\xt_soapapi-php\ArrayType\ArrayOfEcartStock
     */
    public function setEcartStock(array $ecartStock = array())
    {
        // validation for constraint: array
        if ('' !== ($ecartStockArrayErrorMessage = self::validateEcartStockForArrayConstraintsFromSetEcartStock($ecartStock))) {
            throw new \InvalidArgumentException($ecartStockArrayErrorMessage, __LINE__);
        }
        if (is_null($ecartStock) || (is_array($ecartStock) && empty($ecartStock))) {
            unset($this->EcartStock);
        } else {
            $this->EcartStock = $ecartStock;
        }
        return $this;
    }
    /**
     * Add item to EcartStock value
     * @throws \InvalidArgumentException
     * @param \xt_soapapi\xt_soapapi-php\StructType\EcartStock $item
     * @return \xt_soapapi\xt_soapapi-php\ArrayType\ArrayOfEcartStock
     */
    public function addToEcartStock(\xt_soapapi\xt_soapapi-php\StructType\EcartStock $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \xt_soapapi\xt_soapapi-php\StructType\EcartStock) {
            throw new \InvalidArgumentException(sprintf('The EcartStock property can only contain items of type \xt_soapapi\xt_soapapi-php\StructType\EcartStock, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EcartStock[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \xt_soapapi\xt_soapapi-php\StructType\EcartStock|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \xt_soapapi\xt_soapapi-php\StructType\EcartStock|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \xt_soapapi\xt_soapapi-php\StructType\EcartStock|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \xt_soapapi\xt_soapapi-php\StructType\EcartStock|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \xt_soapapi\xt_soapapi-php\StructType\EcartStock|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EcartStock
     */
    public function getAttributeName()
    {
        return 'EcartStock';
    }
}
